/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include <dawn/dawn.h>
#include "../input/input.h"
#include "../epoch/epoch.h"
#include "../util/array.h"

/**
 * Initialize a menu.
 * 
 * @param menu Menu to initialize.
 * @param columns Count of rows.
 * @param rows Count of columns.
 */
void menuInit(menu_t *menu);

/**
 * Updates the menu to handle inputs.
 * 
 * @param menu Menu to update.
 * @param engine Engine to update from.
 */
void menuUpdate(menu_t *menu, engine_t *engine);

/**
 * Add an item to the menu
 * 
 * @param menu Menu to add to.
 * @return Item to add to.
 */
menuitem_t * menuAdd(menu_t *menu);